Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileManager.cpp	(revision 75183)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileManager.cpp	(revision 75184)
@@ -75,4 +75,10 @@
 {
     delete m_pInstance;
+    m_pInstance = 0;
+}
+
+ UIGuestControlFileManagerSettings::~UIGuestControlFileManagerSettings()
+{
+
 }
 
@@ -671,5 +677,4 @@
         return false;
     }
-
     return true;
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileManager.h	(revision 75183)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileManager.h	(revision 75184)
@@ -61,5 +61,5 @@
 private:
     UIGuestControlFileManagerSettings();
-
+    ~UIGuestControlFileManagerSettings();
 
     static UIGuestControlFileManagerSettings *m_pInstance;
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileTable.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileTable.cpp	(revision 75183)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileTable.cpp	(revision 75184)
@@ -1209,56 +1209,4 @@
     Q_UNUSED(deselected);
     setSelectionDependentActionsEnabled(m_pView->hasSelection());
-}
-
-void UIGuestControlFileTable::prepareActionConnections()
-{
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_GoUp), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltGoUp);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_GoUp), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltGoUp);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_GoHome), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltGoHome);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_GoHome), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltGoHome);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Refresh), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltRefresh);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Refresh), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltRefresh);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Delete), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltDelete);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Delete), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltDelete);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Rename), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltRename);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Rename), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltRename);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Copy), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltCopy);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Copy), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltCopy);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Cut), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltCut);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Cut), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltCut);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Paste), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltPaste);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Paste), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltPaste);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_SelectAll), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltSelectAll);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_SelectAll), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltSelectAll);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_InvertSelection), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltInvertSelection);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_InvertSelection), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltInvertSelection);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_ShowProperties), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltShowProperties);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_ShowProperties), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltShowProperties);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_CreateNewDirectory), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltCreateNewDirectory);
-    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_CreateNewDirectory), &QAction::triggered,
-            this, &UIGuestControlFileTable::sltCreateNewDirectory);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileTable.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileTable.h	(revision 75183)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestControlFileTable.h	(revision 75184)
@@ -294,6 +294,4 @@
     CGuestFsObjInfo  guestFsObjectInfo(const QString& path, CGuestSession &comGuestSession) const;
     void             setSelectionDependentActionsEnabled(bool fIsEnabled);
-    void             prepareActionConnections();
-
 
     UIFileTableItem         *m_pRootItem;
@@ -309,11 +307,8 @@
     QSet<QAction*> m_selectionDependentActions;
 
-protected slots:
+public slots:
 
     void sltReceiveDirectoryStatistics(UIDirectoryStatistics statictics);
     void sltCreateNewDirectory();
-
-private slots:
-
     /* index is passed by the item view and represents the double clicked object's 'proxy' model index */
     void sltItemDoubleClicked(const QModelIndex &index);
@@ -328,5 +323,4 @@
     void sltPaste();
     void sltShowProperties();
-
     void sltSelectionChanged(const QItemSelection & selected, const QItemSelection & deselected);
     void sltLocationComboCurrentChange(const QString &strLocation);
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestFileTable.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestFileTable.cpp	(revision 75183)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestFileTable.cpp	(revision 75184)
@@ -21,5 +21,4 @@
 
 /* Qt includes: */
-// # include <QAction>
 # include <QDateTime>
 # include <QFileInfo>
@@ -30,4 +29,5 @@
 # include "UIErrorString.h"
 # include "UIGuestFileTable.h"
+# include "UIMessageCenter.h"
 # include "UIToolBar.h"
 
@@ -310,11 +310,4 @@
 }
 
-void UIGuestFileTable::copyGuestToHost(const QString& hostDestinationPath)
-{
-    QStringList selectedPathList = selectedItemPathList();
-    for (int i = 0; i < selectedPathList.size(); ++i)
-        copyGuestToHost(selectedPathList.at(i), hostDestinationPath);
-}
-
 void UIGuestFileTable::copyHostToGuest(const QStringList &hostSourcePathList)
 {
@@ -322,93 +315,45 @@
     QVector<QString>  aFilters;
     QVector<QString>  aFlags;
-    m_comGuestSession.CopyToGuest(sourcePaths, aFilters, aFlags, currentDirectoryPath());
-    if (!m_comGuestSession.isOk())
-        emit sigLogOutput(UIErrorString::formatErrorInfo(m_comGuestSession));
+    CProgress progress = m_comGuestSession.CopyToGuest(sourcePaths, aFilters, aFlags, currentDirectoryPath());
+    if (!m_comGuestSession.isOk())
+    {
+        emit sigLogOutput(UIErrorString::formatErrorInfo(m_comGuestSession));
+        //msgCenter().cannotRemoveMachine(machine);
+        return;
+    }
+
+    msgCenter().showModalProgressDialog(progress, "copying", ":/progress_delete_90px.png");
+    if (!progress.isOk() || progress.GetResultCode() != 0)
+    {
+        emit sigLogOutput(UIErrorString::formatErrorInfo(progress));
+        return;
+    }
+
     else
         refresh();
 }
 
-bool UIGuestFileTable::copyGuestToHost(const QString &guestSourcePath, const QString& hostDestinationPath)
-{
-    if (m_comGuestSession.isNull())
-        return false;
-
-    /* Currently API expects a path including a file name for file copy*/
-    CGuestFsObjInfo fileInfo = guestFsObjectInfo(guestSourcePath, m_comGuestSession);
-    KFsObjType objectType = fileInfo.GetType();
-    if (objectType == KFsObjType_File)
-    {
-        QVector<KFileCopyFlag> flags(KFileCopyFlag_FollowLinks);
-        /* API expects a full file path as destionation: */
-        QString destinatioFilePath =  UIPathOperations::addTrailingDelimiters(hostDestinationPath);
-        /** @todo listen to CProgress object to monitor copy operation: */
-        /*CProgress comProgress =*/ m_comGuestSession.FileCopyFromGuest(guestSourcePath, destinatioFilePath, flags);
-
-    }
-    else if (objectType == KFsObjType_Directory)
-    {
-        QVector<KDirectoryCopyFlag> aFlags(KDirectoryCopyFlag_CopyIntoExisting);
-        QString destinatioFilePath =  UIPathOperations::addTrailingDelimiters(hostDestinationPath);
-        QString sourceWithDelimiter =  UIPathOperations::addTrailingDelimiters(guestSourcePath);
-
-        /** @todo listen to CProgress object to monitor copy operation: */
-        /*CProgress comProgress = */
-        // m_comGuestSession.DirectoryCopyFromGuest(guestSourcePath, hostDestinationPath/*destinatioFilePath*/ , aFlags);
-        // m_comGuestSession.DirectoryCopyFromGuest(guestSourcePath, destinatioFilePath , aFlags);
-        // m_comGuestSession.DirectoryCopyFromGuest(sourceWithDelimiter, destinatioFilePath , aFlags);
-        // m_comGuestSession.DirectoryCopyFromGuest(sourceWithDelimiter, hostDestinationPath , aFlags);
-
-    }
-    if (!m_comGuestSession.isOk())
-    {
-        emit sigLogOutput(UIErrorString::formatErrorInfo(m_comGuestSession));
-        return false;
-    }
-
-    return true;
-}
-
-// bool UIGuestFileTable::copyHostToGuest(const QString &hostSourcePath, const QString &guestDestinationPath)
-// {
-//     if (m_comGuestSession.isNull())
-//         return false;
-//     QFileInfo hostFileInfo(hostSourcePath);
-//     if (!hostFileInfo.exists())
-//         return false;
-//     CProgress comProgress;
-//     /* Currently API expects a path including a file name for file copy*/
-//     if (hostFileInfo.isFile() || hostFileInfo.isSymLink())
-//     {
-//         QVector<KFileCopyFlag> flags(KFileCopyFlag_FollowLinks);
-//         QString destinationFilePath =  UIPathOperations::addTrailingDelimiters(guestDestinationPath);
-//         /** @todo listen to CProgress object to monitor copy operation: */
-//         comProgress = m_comGuestSession.FileCopyToGuest(hostSourcePath, destinationFilePath, flags);
-//     }
-//     else if(hostFileInfo.isDir())
-//     {
-
-//         QVector<KDirectoryCopyFlag> aFlags(KDirectoryCopyFlag_CopyIntoExisting);
-//         QString destinationFilePath =  UIPathOperations::addTrailingDelimiters(guestDestinationPath);
-//         /** @todo listen to CProgress object to monitor copy operation: */
-//         comProgress = m_comGuestSession.DirectoryCopyToGuest(hostSourcePath, destinationFilePath, aFlags);
-//     }
-//     /** @todo currently I cannot get an errorfrom CProgress: */
-//     if (m_comGuestSession.isOk())
-//     {
-//         if (!comProgress.isOk() || comProgress.GetResultCode() != 0)
-//         {
-//             emit sigLogOutput(UIErrorString::formatErrorInfo(comProgress));
-//             return false;
-//         }
-//     }
-//     else
-//     {
-//         emit sigLogOutput(UIErrorString::formatErrorInfo(m_comGuestSession));
-//         return false;
-//     }
-//     /** @todo we have to until CProgress finishes to refresh: */
-//     refresh();
-//     return true;
-// }
+void UIGuestFileTable::copyGuestToHost(const QString& hostDestinationPath)
+{
+    QVector<QString> sourcePaths;// = selectedItemPathList().toVector();
+    QVector<QString>  aFilters;
+    QVector<QString>  aFlags;
+    sourcePaths.append("opt/VBoxGuestAdditions-5.2.97/bin/");
+    CProgress progress = m_comGuestSession.CopyFromGuest(sourcePaths, aFilters, aFlags, hostDestinationPath);
+    if (!m_comGuestSession.isOk())
+    {
+        emit sigLogOutput(UIErrorString::formatErrorInfo(m_comGuestSession));
+        return;
+    }
+
+    msgCenter().showModalProgressDialog(progress, "copying", ":/progress_delete_90px.png");
+    if (!progress.isOk() || progress.GetResultCode() != 0)
+    {
+        emit sigLogOutput(UIErrorString::formatErrorInfo(progress));
+        return;
+    }
+    else
+        refresh();
+}
 
 FileObjectType UIGuestFileTable::fileType(const CFsObjInfo &fsInfo)
@@ -524,6 +469,4 @@
         return;
 
-    delete m_pPropertiesDialog;
-
     m_pPropertiesDialog = new UIPropertiesDialog();
     if (!m_pPropertiesDialog)
@@ -533,9 +476,6 @@
     if (selectedObjects.size() == 0)
         return;
-    UIGuestDirectoryDiskUsageComputer *directoryThread = 0;
-
-    /** @todo I have decided to look into this afterwards when API is more mature, for
-        currently this stuff runs into an assert in Main. this may be because that I will have to init deinit
-        COM. see UIThreadWorker: */
+    //UIGuestDirectoryDiskUsageComputer *directoryThread = 0;
+
     /* if the selection include a directory or it is a multiple selection the create a worker thread
        to compute total size of the selection (recusively) */
@@ -559,13 +499,16 @@
     m_pPropertiesDialog->execute();
 
-    if (directoryThread)
-    {
-        if (directoryThread->isRunning())
-            directoryThread->stopRecursion();
-        disconnect(directoryThread, &UIGuestDirectoryDiskUsageComputer::sigResultUpdated,
-                   this, &UIGuestFileTable::sltReceiveDirectoryStatistics/*, Qt::DirectConnection*/);
-    }
+    // if (directoryThread)
+    // {
+    //     if (directoryThread->isRunning())
+    //         directoryThread->stopRecursion();
+    //     disconnect(directoryThread, &UIGuestDirectoryDiskUsageComputer::sigResultUpdated,
+    //                this, &UIGuestFileTable::sltReceiveDirectoryStatistics/*, Qt::DirectConnection*/);
+    // }
+
 
     delete m_pPropertiesDialog;
+    m_pPropertiesDialog = 0;
+
 }
 
@@ -611,5 +554,4 @@
         m_pToolBar->addSeparator();
         m_pToolBar->addAction(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_ShowProperties));
-
         m_selectionDependentActions.insert(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Delete));
         m_selectionDependentActions.insert(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Rename));
@@ -617,8 +559,35 @@
         m_selectionDependentActions.insert(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Cut));
         m_selectionDependentActions.insert(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_ShowProperties));
-
     }
     setSelectionDependentActionsEnabled(false);
 }
 
+void UIGuestFileTable::prepareActionConnections()
+{
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_GoUp), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltGoUp);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_GoHome), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltGoHome);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Refresh), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltRefresh);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Delete), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltDelete);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Rename), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltRename);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Copy), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltCopy);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Cut), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltCut);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Paste), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltPaste);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_SelectAll), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltSelectAll);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_InvertSelection), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltInvertSelection);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_ShowProperties), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltShowProperties);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_CreateNewDirectory), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltCreateNewDirectory);
+}
+
 #include "UIGuestFileTable.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestFileTable.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestFileTable.h	(revision 75183)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestFileTable.h	(revision 75184)
@@ -55,5 +55,4 @@
     virtual void    prepareToolbar() /* override */;
 
-
 private:
 
@@ -61,6 +60,6 @@
     FileObjectType  fileType(const CGuestFsObjInfo &fsInfo);
 
-    bool copyGuestToHost(const QString &guestSourcePath, const QString& hostDestinationPath);
-    bool copyHostToGuest(const QString& hostSourcePath, const QString &guestDestinationPath);
+    void prepareActionConnections();
+
     mutable CGuestSession m_comGuestSession;
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIHostFileTable.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIHostFileTable.cpp	(revision 75183)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIHostFileTable.cpp	(revision 75184)
@@ -375,8 +375,6 @@
     if (fsPropertyString.isEmpty())
         return;
-
-    delete m_pPropertiesDialog;
-
-    m_pPropertiesDialog = new UIPropertiesDialog();
+    if (!m_pPropertiesDialog)
+        m_pPropertiesDialog = new UIPropertiesDialog(this);
     if (!m_pPropertiesDialog)
         return;
@@ -402,22 +400,15 @@
     {
         if (directoryThread->isRunning())
-        {
             directoryThread->stopRecursion();
-            //directoryThread->wait();
-        }
         disconnect(directoryThread, &UIHostDirectoryDiskUsageComputer::sigResultUpdated,
                 this, &UIHostFileTable::sltReceiveDirectoryStatistics/*, Qt::DirectConnection*/);
-        //delete directoryThread;
-    }
-    delete m_pPropertiesDialog;
-    m_pPropertiesDialog = 0;
+        directoryThread->wait();
+    }
 }
 
 void UIHostFileTable::determineDriveLetters()
 {
-    //#ifdef VBOX_WS_WIN
-
     QFileInfoList drive = QDir::drives();
-
+    m_driveLetterList.clear();
     for (int i = 0; i < drive.size(); ++i)
     {
@@ -426,5 +417,4 @@
 
     }
-    //#endif
 }
 
@@ -476,11 +466,58 @@
     else
         strPermissions += '-';
-
-
-
-
-
     return strPermissions;
 }
 
+void UIHostFileTable::prepareActionConnections()
+{
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_GoUp), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltGoUp);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_GoUp), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltGoUp);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_GoHome), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltGoHome);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_GoHome), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltGoHome);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Refresh), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltRefresh);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Refresh), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltRefresh);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Delete), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltDelete);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Delete), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltDelete);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Rename), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltRename);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Rename), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltRename);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Copy), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltCopy);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Copy), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltCopy);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Cut), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltCut);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Cut), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltCut);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_Paste), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltPaste);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_Paste), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltPaste);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_SelectAll), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltSelectAll);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_SelectAll), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltSelectAll);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_InvertSelection), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltInvertSelection);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_InvertSelection), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltInvertSelection);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_ShowProperties), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltShowProperties);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_ShowProperties), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltShowProperties);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Guest_CreateNewDirectory), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltCreateNewDirectory);
+    connect(m_pActionPool->action(UIActionIndex_M_GuestControlFileManager_S_Host_CreateNewDirectory), &QAction::triggered,
+            this, &UIGuestControlFileTable::sltCreateNewDirectory);
+}
+
 #include "UIHostFileTable.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIHostFileTable.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIHostFileTable.h	(revision 75183)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIHostFileTable.h	(revision 75184)
@@ -52,4 +52,6 @@
 
     QString permissionString(QFileDevice::Permissions permissions);
+    void    prepareActionConnections();
+
 };
 