Index: trunk/src/VBox/Main/include/CaptureScreenSettingsImpl.h
===================================================================
--- trunk/src/VBox/Main/include/CaptureScreenSettingsImpl.h	(revision 75326)
+++ 	(revision )
@@ -1,116 +1,0 @@
-/* $Id$ */
-
-/** @file
- *
- * VirtualBox COM class implementation - Capture settings of one virtual screen.
- */
-
-/*
- * Copyright (C) 2018 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifndef ____H_CAPTURESCREENSETTINGS
-#define ____H_CAPTURESCREENSETTINGS
-
-#include "CaptureScreenSettingsWrap.h"
-
-class CaptureSettings;
-
-namespace settings
-{
-    struct CaptureScreenSettings;
-}
-
-class ATL_NO_VTABLE CaptureScreenSettings :
-    public CaptureScreenSettingsWrap
-{
-public:
-
-    DECLARE_EMPTY_CTOR_DTOR(CaptureScreenSettings)
-
-    HRESULT FinalConstruct();
-    void FinalRelease();
-
-    // public initializer/uninitializer for internal purposes only
-    HRESULT init(CaptureSettings *aParent, uint32_t uScreenId, const settings::CaptureScreenSettings& data);
-    HRESULT init(CaptureSettings *aParent, CaptureScreenSettings *that);
-    HRESULT initCopy(CaptureSettings *aParent, CaptureScreenSettings *that);
-    void uninit();
-
-    // public methods only for internal purposes
-    HRESULT i_loadSettings(const settings::CaptureScreenSettings &data);
-    HRESULT i_saveSettings(settings::CaptureScreenSettings &data);
-
-    void i_rollback();
-    void i_commit();
-    void i_copyFrom(CaptureScreenSettings *aThat);
-    void i_applyDefaults();
-
-private:
-
-    // wrapped ICaptureScreenSettings methods
-    HRESULT isFeatureEnabled(CaptureFeature_T aFeature, BOOL *aEnabled);
-
-    // wrapped ICaptureScreenSettings properties
-    HRESULT getId(ULONG *id);
-    HRESULT getEnabled(BOOL *enabled);
-    HRESULT setEnabled(BOOL enabled);
-    HRESULT getFeatures(ULONG *aFeatures);
-    HRESULT setFeatures(ULONG aFeatures);
-    HRESULT getDestination(CaptureDestination_T *aDestination);
-    HRESULT setDestination(CaptureDestination_T aDestination);
-
-    HRESULT getFileName(com::Utf8Str &aFileName);
-    HRESULT setFileName(const com::Utf8Str &aFileName);
-    HRESULT getMaxTime(ULONG *aMaxTimeS);
-    HRESULT setMaxTime(ULONG aMaxTimeS);
-    HRESULT getMaxFileSize(ULONG *aMaxFileSizeMB);
-    HRESULT setMaxFileSize(ULONG aMaxFileSizeMB);
-    HRESULT getOptions(com::Utf8Str &aOptions);
-    HRESULT setOptions(const com::Utf8Str &aOptions);
-
-    HRESULT getAudioCodec(CaptureAudioCodec_T *aCodec);
-    HRESULT setAudioCodec(CaptureAudioCodec_T aCodec);
-    HRESULT getAudioHz(ULONG *aHz);
-    HRESULT setAudioHz(ULONG aHz);
-    HRESULT getAudioBits(ULONG *aBits);
-    HRESULT setAudioBits(ULONG aBits);
-    HRESULT getAudioChannels(ULONG *aChannels);
-    HRESULT setAudioChannels(ULONG aChannels);
-
-    HRESULT getVideoCodec(CaptureVideoCodec_T *aCodec);
-    HRESULT setVideoCodec(CaptureVideoCodec_T aCodec);
-    HRESULT getVideoWidth(ULONG *aVideoWidth);
-    HRESULT setVideoWidth(ULONG aVideoWidth);
-    HRESULT getVideoHeight(ULONG *aVideoHeight);
-    HRESULT setVideoHeight(ULONG aVideoHeight);
-    HRESULT getVideoRate(ULONG *aVideoRate);
-    HRESULT setVideoRate(ULONG aVideoRate);
-    HRESULT getVideoRateControlMode(CaptureVideoRateControlMode_T *aMode);
-    HRESULT setVideoRateControlMode(CaptureVideoRateControlMode_T aMode);
-    HRESULT getVideoFPS(ULONG *aVideoFPS);
-    HRESULT setVideoFPS(ULONG aVideoFPS);
-    HRESULT getVideoScalingMethod(CaptureVideoScalingMethod_T *aMode);
-    HRESULT setVideoScalingMethod(CaptureVideoScalingMethod_T aMode);
-
-private:
-
-    // internal methods
-    int  i_initInternal();
-
-private:
-
-    struct Data;
-    Data *m;
-};
-
-#endif // ____H_CAPTURESCREENSETTINGS
-
Index: trunk/src/VBox/Main/include/CaptureSettingsImpl.h
===================================================================
--- trunk/src/VBox/Main/include/CaptureSettingsImpl.h	(revision 75326)
+++ 	(revision )
@@ -1,89 +1,0 @@
-/* $Id$ */
-
-/** @file
- *
- * VirtualBox COM class implementation - Machine capture settings.
- */
-
-/*
- * Copyright (C) 2018 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifndef ____H_CAPTURESETTINGS
-#define ____H_CAPTURESETTINGS
-
-#include "CaptureSettingsWrap.h"
-
-namespace settings
-{
-    struct CaptureSettings;
-    struct CaptureScreenSettings;
-}
-
-class CaptureScreenSettings;
-
-class ATL_NO_VTABLE CaptureSettings :
-    public CaptureSettingsWrap
-{
-public:
-
-    DECLARE_EMPTY_CTOR_DTOR(CaptureSettings)
-
-    HRESULT FinalConstruct();
-    void FinalRelease();
-
-    // public initializer/uninitializer for internal purposes only
-    HRESULT init(Machine *parent);
-    HRESULT init(Machine *parent, CaptureSettings *that);
-    HRESULT initCopy(Machine *parent, CaptureSettings *that);
-    void uninit();
-
-    // public methods only for internal purposes
-    HRESULT i_loadSettings(const settings::CaptureSettings &data);
-    HRESULT i_saveSettings(settings::CaptureSettings &data);
-
-    void i_rollback();
-    void i_commit();
-    void i_copyFrom(CaptureSettings *aThat);
-    void i_applyDefaults(void);
-
-    int i_getDefaultFileName(Utf8Str &strFile);
-    bool i_canChangeSettings(void);
-    void i_onSettingsChanged(void);
-
-private:
-
-    /** Map of screen settings objects. The key specifies the screen ID. */
-    typedef std::map <uint32_t, ComObjPtr<CaptureScreenSettings> > CaptureScreenSettingsMap;
-
-    void i_reset(void);
-    int i_syncToMachineDisplays(void);
-    int i_createScreenObj(CaptureScreenSettingsMap &screenSettingsMap, uint32_t uScreenId, const settings::CaptureScreenSettings &data);
-    int i_destroyScreenObj(CaptureScreenSettingsMap &screenSettingsMap, uint32_t uScreenId);
-    int i_destroyAllScreenObj(CaptureScreenSettingsMap &screenSettingsMap);
-
-private:
-
-    // wrapped ICaptureSettings properties
-    HRESULT getEnabled(BOOL *enabled);
-    HRESULT setEnabled(BOOL enable);
-    HRESULT getScreens(std::vector<ComPtr<ICaptureScreenSettings> > &aCaptureScreenSettings);
-
-    // wrapped ICaptureSettings methods
-    HRESULT getScreenSettings(ULONG uScreenId, ComPtr<ICaptureScreenSettings> &aCaptureScreenSettings);
-
-private:
-
-    struct Data;
-    Data *m;
-};
-#endif // ____H_CAPTURESETTINGS
-
Index: trunk/src/VBox/Main/include/ConsoleImpl.h
===================================================================
--- trunk/src/VBox/Main/include/ConsoleImpl.h	(revision 75326)
+++ trunk/src/VBox/Main/include/ConsoleImpl.h	(revision 75341)
@@ -145,5 +145,5 @@
     void i_videoRecDestroy(void);
     int i_videoRecEnable(BOOL fEnable, util::AutoWriteLock *pAutoLock);
-    int i_videoRecGetSettings(settings::CaptureSettings &Settings);
+    int i_videoRecGetSettings(settings::RecordSettings &Settings);
     int i_videoRecStart(void);
     int i_videoRecStop(void);
@@ -179,5 +179,5 @@
     HRESULT i_onDnDModeChange(DnDMode_T aDnDMode);
     HRESULT i_onVRDEServerChange(BOOL aRestart);
-    HRESULT i_onCaptureChange();
+    HRESULT i_onRecordChange();
     HRESULT i_onUSBControllerChange();
     HRESULT i_onSharedFolderChange(BOOL aGlobal);
Index: trunk/src/VBox/Main/include/DrvAudioVideoRec.h
===================================================================
--- trunk/src/VBox/Main/include/DrvAudioVideoRec.h	(revision 75326)
+++ trunk/src/VBox/Main/include/DrvAudioVideoRec.h	(revision 75341)
@@ -45,5 +45,5 @@
 public:
 
-    int applyConfiguration(const settings::CaptureSettings &Settings);
+    int applyConfiguration(const settings::RecordSettings &Settings);
 
 public:
@@ -61,5 +61,5 @@
     struct DRVAUDIOVIDEOREC         *mpDrv;
     /** Capturing configuration used for configuring the driver. */
-    struct settings::CaptureSettings mVideoRecCfg;
+    struct settings::RecordSettings mVideoRecCfg;
 };
 
Index: trunk/src/VBox/Main/include/MachineImpl.h
===================================================================
--- trunk/src/VBox/Main/include/MachineImpl.h	(revision 75326)
+++ trunk/src/VBox/Main/include/MachineImpl.h	(revision 75341)
@@ -32,5 +32,5 @@
 #include "ParallelPortImpl.h"
 #include "BIOSSettingsImpl.h"
-#include "CaptureSettingsImpl.h"
+#include "RecordSettingsImpl.h"
 #include "StorageControllerImpl.h"          // required for MachineImpl.h to compile on Windows
 #include "USBControllerImpl.h"              // required for MachineImpl.h to compile on Windows
@@ -266,5 +266,5 @@
         GraphicsControllerType_T mGraphicsControllerType;
         ULONG               mVRAMSize;
-        settings::CaptureSettings mCaptureSettings;
+        settings::RecordSettings mRecordSettings;
         ULONG               mMonitorCount;
         BOOL                mHWVirtExEnabled;
@@ -477,5 +477,5 @@
         IsModified_Snapshots            = 0x0800,
         IsModified_BandwidthControl     = 0x1000,
-        IsModified_Capture              = 0x2000
+        IsModified_Record               = 0x2000
     };
 
@@ -524,5 +524,5 @@
     virtual HRESULT i_onStorageDeviceChange(IMediumAttachment * /* mediumAttachment */, BOOL /* remove */,
                                             BOOL /* silent */) { return S_OK; }
-    virtual HRESULT i_onCaptureChange() { return S_OK; }
+    virtual HRESULT i_onRecordChange() { return S_OK; }
 
     HRESULT i_saveRegistryEntry(settings::MachineRegistryEntry &data);
@@ -777,5 +777,5 @@
     const ComObjPtr<USBDeviceFilters>  mUSBDeviceFilters;
     const ComObjPtr<BIOSSettings>      mBIOSSettings;
-    const ComObjPtr<CaptureSettings>   mCaptureSettings;
+    const ComObjPtr<RecordSettings>    mRecordSettings;
     const ComObjPtr<BandwidthControl>  mBandwidthControl;
 
@@ -825,6 +825,6 @@
 
     friend class Appliance;
-    friend class CaptureSettings;
-    friend class CaptureScreenSettings;
+    friend class RecordSettings;
+    friend class RecordScreenSettings;
     friend class SessionMachine;
     friend class SnapshotMachine;
@@ -880,5 +880,5 @@
     HRESULT setMonitorCount(ULONG aMonitorCount);
     HRESULT getBIOSSettings(ComPtr<IBIOSSettings> &aBIOSSettings);
-    HRESULT getCaptureSettings(ComPtr<ICaptureSettings> &aCaptureSettings);
+    HRESULT getRecordSettings(ComPtr<IRecordSettings> &aRecordSettings);
     HRESULT getFirmwareType(FirmwareType_T *aFirmwareType);
     HRESULT setFirmwareType(FirmwareType_T aFirmwareType);
@@ -1326,5 +1326,5 @@
     HRESULT i_onCPUChange(ULONG aCPU, BOOL aRemove);
     HRESULT i_onVRDEServerChange(BOOL aRestart);
-    HRESULT i_onCaptureChange();
+    HRESULT i_onRecordChange();
     HRESULT i_onUSBControllerChange();
     HRESULT i_onUSBDeviceAttach(IUSBDevice *aDevice,
Index: trunk/src/VBox/Main/include/RecordScreenSettingsImpl.h
===================================================================
--- trunk/src/VBox/Main/include/RecordScreenSettingsImpl.h	(revision 75341)
+++ trunk/src/VBox/Main/include/RecordScreenSettingsImpl.h	(revision 75341)
@@ -0,0 +1,116 @@
+/* $Id$ */
+
+/** @file
+ *
+ * VirtualBox COM class implementation - Capture settings of one virtual screen.
+ */
+
+/*
+ * Copyright (C) 2018 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef ____H_RecordScreenSettings
+#define ____H_RecordScreenSettings
+
+#include "RecordScreenSettingsWrap.h"
+
+class RecordSettings;
+
+namespace settings
+{
+    struct RecordScreenSettings;
+}
+
+class ATL_NO_VTABLE RecordScreenSettings :
+    public RecordScreenSettingsWrap
+{
+public:
+
+    DECLARE_EMPTY_CTOR_DTOR(RecordScreenSettings)
+
+    HRESULT FinalConstruct();
+    void FinalRelease();
+
+    // public initializer/uninitializer for internal purposes only
+    HRESULT init(RecordSettings *aParent, uint32_t uScreenId, const settings::RecordScreenSettings& data);
+    HRESULT init(RecordSettings *aParent, RecordScreenSettings *that);
+    HRESULT initCopy(RecordSettings *aParent, RecordScreenSettings *that);
+    void uninit();
+
+    // public methods only for internal purposes
+    HRESULT i_loadSettings(const settings::RecordScreenSettings &data);
+    HRESULT i_saveSettings(settings::RecordScreenSettings &data);
+
+    void i_rollback();
+    void i_commit();
+    void i_copyFrom(RecordScreenSettings *aThat);
+    void i_applyDefaults();
+
+private:
+
+    // wrapped IRecordScreenSettings methods
+    HRESULT isFeatureEnabled(RecordFeature_T aFeature, BOOL *aEnabled);
+
+    // wrapped IRecordScreenSettings properties
+    HRESULT getId(ULONG *id);
+    HRESULT getEnabled(BOOL *enabled);
+    HRESULT setEnabled(BOOL enabled);
+    HRESULT getFeatures(ULONG *aFeatures);
+    HRESULT setFeatures(ULONG aFeatures);
+    HRESULT getDestination(RecordDestination_T *aDestination);
+    HRESULT setDestination(RecordDestination_T aDestination);
+
+    HRESULT getFileName(com::Utf8Str &aFileName);
+    HRESULT setFileName(const com::Utf8Str &aFileName);
+    HRESULT getMaxTime(ULONG *aMaxTimeS);
+    HRESULT setMaxTime(ULONG aMaxTimeS);
+    HRESULT getMaxFileSize(ULONG *aMaxFileSizeMB);
+    HRESULT setMaxFileSize(ULONG aMaxFileSizeMB);
+    HRESULT getOptions(com::Utf8Str &aOptions);
+    HRESULT setOptions(const com::Utf8Str &aOptions);
+
+    HRESULT getAudioCodec(RecordAudioCodec_T *aCodec);
+    HRESULT setAudioCodec(RecordAudioCodec_T aCodec);
+    HRESULT getAudioHz(ULONG *aHz);
+    HRESULT setAudioHz(ULONG aHz);
+    HRESULT getAudioBits(ULONG *aBits);
+    HRESULT setAudioBits(ULONG aBits);
+    HRESULT getAudioChannels(ULONG *aChannels);
+    HRESULT setAudioChannels(ULONG aChannels);
+
+    HRESULT getVideoCodec(RecordVideoCodec_T *aCodec);
+    HRESULT setVideoCodec(RecordVideoCodec_T aCodec);
+    HRESULT getVideoWidth(ULONG *aVideoWidth);
+    HRESULT setVideoWidth(ULONG aVideoWidth);
+    HRESULT getVideoHeight(ULONG *aVideoHeight);
+    HRESULT setVideoHeight(ULONG aVideoHeight);
+    HRESULT getVideoRate(ULONG *aVideoRate);
+    HRESULT setVideoRate(ULONG aVideoRate);
+    HRESULT getVideoRateControlMode(RecordVideoRateControlMode_T *aMode);
+    HRESULT setVideoRateControlMode(RecordVideoRateControlMode_T aMode);
+    HRESULT getVideoFPS(ULONG *aVideoFPS);
+    HRESULT setVideoFPS(ULONG aVideoFPS);
+    HRESULT getVideoScalingMethod(RecordVideoScalingMethod_T *aMode);
+    HRESULT setVideoScalingMethod(RecordVideoScalingMethod_T aMode);
+
+private:
+
+    // internal methods
+    int  i_initInternal();
+
+private:
+
+    struct Data;
+    Data *m;
+};
+
+#endif // ____H_RecordScreenSettings
+
Index: trunk/src/VBox/Main/include/RecordSettingsImpl.h
===================================================================
--- trunk/src/VBox/Main/include/RecordSettingsImpl.h	(revision 75341)
+++ trunk/src/VBox/Main/include/RecordSettingsImpl.h	(revision 75341)
@@ -0,0 +1,89 @@
+/* $Id$ */
+
+/** @file
+ *
+ * VirtualBox COM class implementation - Machine capture settings.
+ */
+
+/*
+ * Copyright (C) 2018 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef ____H_RecordSettings
+#define ____H_RecordSettings
+
+#include "RecordSettingsWrap.h"
+
+namespace settings
+{
+    struct RecordSettings;
+    struct RecordScreenSettings;
+}
+
+class RecordScreenSettings;
+
+class ATL_NO_VTABLE RecordSettings :
+    public RecordSettingsWrap
+{
+public:
+
+    DECLARE_EMPTY_CTOR_DTOR(RecordSettings)
+
+    HRESULT FinalConstruct();
+    void FinalRelease();
+
+    // public initializer/uninitializer for internal purposes only
+    HRESULT init(Machine *parent);
+    HRESULT init(Machine *parent, RecordSettings *that);
+    HRESULT initCopy(Machine *parent, RecordSettings *that);
+    void uninit();
+
+    // public methods only for internal purposes
+    HRESULT i_loadSettings(const settings::RecordSettings &data);
+    HRESULT i_saveSettings(settings::RecordSettings &data);
+
+    void i_rollback();
+    void i_commit();
+    void i_copyFrom(RecordSettings *aThat);
+    void i_applyDefaults(void);
+
+    int i_getDefaultFileName(Utf8Str &strFile);
+    bool i_canChangeSettings(void);
+    void i_onSettingsChanged(void);
+
+private:
+
+    /** Map of screen settings objects. The key specifies the screen ID. */
+    typedef std::map <uint32_t, ComObjPtr<RecordScreenSettings> > RecordScreenSettingsMap;
+
+    void i_reset(void);
+    int i_syncToMachineDisplays(void);
+    int i_createScreenObj(RecordScreenSettingsMap &screenSettingsMap, uint32_t uScreenId, const settings::RecordScreenSettings &data);
+    int i_destroyScreenObj(RecordScreenSettingsMap &screenSettingsMap, uint32_t uScreenId);
+    int i_destroyAllScreenObj(RecordScreenSettingsMap &screenSettingsMap);
+
+private:
+
+    // wrapped IRecordSettings properties
+    HRESULT getEnabled(BOOL *enabled);
+    HRESULT setEnabled(BOOL enable);
+    HRESULT getScreens(std::vector<ComPtr<IRecordScreenSettings> > &aRecordScreenSettings);
+
+    // wrapped IRecordSettings methods
+    HRESULT getScreenSettings(ULONG uScreenId, ComPtr<IRecordScreenSettings> &aRecordScreenSettings);
+
+private:
+
+    struct Data;
+    Data *m;
+};
+#endif // ____H_RecordSettings
+
Index: trunk/src/VBox/Main/include/SessionImpl.h
===================================================================
--- trunk/src/VBox/Main/include/SessionImpl.h	(revision 75326)
+++ trunk/src/VBox/Main/include/SessionImpl.h	(revision 75341)
@@ -102,5 +102,5 @@
     HRESULT onCPUExecutionCapChange(ULONG aExecutionCap);
     HRESULT onVRDEServerChange(BOOL aRestart);
-    HRESULT onCaptureChange();
+    HRESULT onRecordChange();
     HRESULT onUSBControllerChange();
     HRESULT onSharedFolderChange(BOOL aGlobal);
Index: trunk/src/VBox/Main/include/VideoRec.h
===================================================================
--- trunk/src/VBox/Main/include/VideoRec.h	(revision 75326)
+++ trunk/src/VBox/Main/include/VideoRec.h	(revision 75341)
@@ -41,5 +41,5 @@
     CaptureContext(Console *pConsole);
 
-    CaptureContext(Console *pConsole, const settings::CaptureSettings &a_Settings);
+    CaptureContext(Console *pConsole, const settings::RecordSettings &a_Settings);
 
     virtual ~CaptureContext(void);
@@ -47,9 +47,9 @@
 public:
 
-    const settings::CaptureSettings &GetConfig(void) const;
+    const settings::RecordSettings &GetConfig(void) const;
     CaptureStream *GetStream(unsigned uScreen) const;
     size_t GetStreamCount(void) const;
 
-    int Create(const settings::CaptureSettings &a_Settings);
+    int Create(const settings::RecordSettings &a_Settings);
     int Destroy(void);
 
@@ -64,5 +64,5 @@
 public:
 
-    bool IsFeatureEnabled(CaptureFeature_T enmFeature) const;
+    bool IsFeatureEnabled(RecordFeature_T enmFeature) const;
     bool IsReady(void) const;
     bool IsReady(uint32_t uScreen, uint64_t uTimeStampMs) const;
@@ -72,5 +72,5 @@
 protected:
 
-    int createInternal(const settings::CaptureSettings &a_Settings);
+    int createInternal(const settings::RecordSettings &a_Settings);
     int startInternal(void);
     int stopInternal(void);
@@ -104,5 +104,5 @@
     Console                  *pConsole;
     /** Used recording configuration. */
-    settings::CaptureSettings Settings;
+    settings::RecordSettings Settings;
     /** The current state. */
     VIDEORECSTS               enmState;
Index: trunk/src/VBox/Main/include/VideoRecStream.h
===================================================================
--- trunk/src/VBox/Main/include/VideoRecStream.h	(revision 75326)
+++ trunk/src/VBox/Main/include/VideoRecStream.h	(revision 75341)
@@ -111,5 +111,5 @@
     CaptureStream(CaptureContext *pCtx);
 
-    CaptureStream(CaptureContext *pCtx, uint32_t uScreen, const settings::CaptureScreenSettings &Settings);
+    CaptureStream(CaptureContext *pCtx, uint32_t uScreen, const settings::RecordScreenSettings &Settings);
 
     virtual ~CaptureStream(void);
@@ -117,5 +117,5 @@
 public:
 
-    int Init(CaptureContext *pCtx, uint32_t uScreen, const settings::CaptureScreenSettings &Settings);
+    int Init(CaptureContext *pCtx, uint32_t uScreen, const settings::RecordScreenSettings &Settings);
     int Uninit(void);
 
@@ -124,5 +124,5 @@
                        uint32_t uSrcWidth, uint32_t uSrcHeight, uint8_t *puSrcData, uint64_t uTimeStampMs);
 
-    const settings::CaptureScreenSettings &GetConfig(void) const;
+    const settings::RecordScreenSettings &GetConfig(void) const;
     bool IsLimitReached(uint64_t tsNowMs) const;
     bool IsReady(void) const;
@@ -130,8 +130,8 @@
 protected:
 
-    int open(const settings::CaptureScreenSettings &Settings);
+    int open(const settings::RecordScreenSettings &Settings);
     int close(void);
 
-    int initInternal(CaptureContext *pCtx, uint32_t uScreen, const settings::CaptureScreenSettings &Settings);
+    int initInternal(CaptureContext *pCtx, uint32_t uScreen, const settings::RecordScreenSettings &Settings);
     int uninitInternal(void);
 
@@ -205,5 +205,5 @@
     } Video;
 
-    settings::CaptureScreenSettings ScreenSettings;
+    settings::RecordScreenSettings ScreenSettings;
     /** Common set of video recording (data) blocks, needed for
      *  multiplexing to all recording streams. */